﻿function updateAnswerCount(CurrentQuestion){
	var count = document.getElementById('AnswerCount-'+CurrentQuestion);
	count.title = parseInt(count.title)+1;
	return count.title;
}

function response(CheckCorrectFunc,frm,getFeedbackFunc,NumberOfAttempts,Survey,param){
	var IsCorrect;
	var CurrentQuestion = frm.id.substr(5);
	var AnswerCount = updateAnswerCount(CurrentQuestion);

//correct/incorrect
	if(Survey==false){
		IsCorrect = CheckCorrectFunc(frm,param);
	}
	else{
		IsCorrect = true;	
	}

//Feedback message 
	writeAnswer(getFeedbackFunc(frm,IsCorrect),CurrentQuestion);
//lock	
	if(IsCorrect || (NumberOfAttempts != 'Unlimited')&& (parseInt(NumberOfAttempts)<=AnswerCount)){
		disableForm(frm);
		if (this.updateLmsStatus==undefined){
			if (parent.updateLmsStatus != undefined) parent.updateLmsStatus(true);
		}
		else updateLmsStatus(true);
	}
}

function Question_Level_Feedback(frm,IsCorrect){
	return document.getElementById('Is'+((IsCorrect)? 'C': 'Inc') +'orrect-message-'+frm.id.substr(5)).title;
}

function None_Feedback(){
	return null;
}

function Answer_Level_Feedback(frm){
	var FeedbackMessage = '';
	var id;
	var fb;
	var GroupObj = frm.choice; 
  	for (var i=0; i < GroupObj.length; i++){
  		if (GroupObj[i].checked) {
  			id = GroupObj[i].id.substr(7);
  			fb = document.getElementById('Feedback-'+id).title;
  			if (FeedbackMessage !='' && fb!='') FeedbackMessage = FeedbackMessage +'<br>';
		  	FeedbackMessage =FeedbackMessage + fb;
  		}
    }
    return FeedbackMessage;
}

function writeAnswer(message,CurrentQuestion){
	if(message != null){
		var answerDiv = document.getElementById('answer-'+CurrentQuestion);
		answerDiv.style.display = 'block';
		answerDiv.innerHTML = message;
	}
}

function getRadioGroupValue(frm)
{
  for (var i=0; i < frm.choice.length; i++)
    if (frm.choice[i].checked){
		return (frm.choice[i].value=='true');
	} 
  return null;
}

function getInputTextValue(frm,choicesCount)
{
	var CurrentQuestion = frm.id.substr(5);

	for (var i=1; i <= choicesCount; i++){
		var ch = document.getElementById('Choice-'+CurrentQuestion+'-'+i).title;
		if (ch.toLowerCase() == frm.choice.value.toLowerCase()) return true;
	}
	return false;
}

function getGapFillValue(frm,FillGapOptions){
	if (FillGapOptions=='Drop-down list'){
		return getComboValue(frm);
	}
	else if(FillGapOptions=='Text box' || FillGapOptions=='Text box and word bank'){
		return getGapFillTextValue(frm);
	}
	return null;
} 


function getComboValue(frm)
{
	var CurrentQuestion = frm.id.substr(5);
	for (var i=1; i <= frm.choice.length; i++){
	    d = document.getElementById('Choice-'+CurrentQuestion+'-'+i);
		position = parseInt(d.value);
		if (position != i){
			if (d.options[d.selectedIndex].text != getOptionByValue(d,i))
			    return false;
		}
	}
	return true;
}

function getOptionByValue(combo,val){
	for (var i=0; i< combo.options.length; i++){
		if (combo.options[i].value == val)
			return combo.options[i].text;
	}
    return "";
}

function getGapFillTextValue(frm)
{
	var CurrentQuestion = frm.id.substr(5);
	choicesCount = (frm.choice.length != undefined) ? frm.choice.length : 1;
	for (var i=1; i <= choicesCount; i++){
		inputchoice = document.getElementById('Choice-'+CurrentQuestion+'-'+i).value;
		ch = document.getElementById('choice-value-'+CurrentQuestion+'-'+i).title;
		if (ch.toLowerCase() != inputchoice.toLowerCase()) return false;
	}
	return true;
}

function getCheckGroupValue(frm)
{
	var result = true;
	var val;
  	for (var i=0; i < frm.choice.length; i++){
  		val = (frm.choice[i].value == 'true');
    	if (frm.choice[i].checked != val) result = false;
    }
	return result;
}

function disableForm(frm){
	var GroupObj = frm.choice;
	frm.submit.src = "image/ok_disabled.jpg";
	GroupObj.disabled = true;
	for (var i=0; i < GroupObj.length; i++)
    GroupObj[i].disabled = true;
    frm.disabled = true;
}


function randomOrder(){
	return (Math.round(Math.random())-0.5); 
}

function writeArray(id){
 	for(var i=0;i < choices.length; i++){
		var p = document.getElementById('p-choice-'+id+'-'+(i+1));
		var el = p.getElementsByTagName('input')[0].value = choices[i][1];
		p.getElementsByTagName('span')[0].title=choices[i][2];
		p.innerHTML += choices[i][0];
	}
}

function writeArrayToCombo(id){
	for(var i=0;i < choices.length; i++){
	    var combo = document.getElementById('Choice-' +id +'-' +(i+1));
	    for(var j=0;j < choices.length; j++){
	        combo.options[j] = new Option(choices[j][0], choices[j][1]);
	        combo.options[j].title = choices[j][0];
	     }
	}
}

function writeArrayToList(id){
	var list = document.getElementById('choice-list-' +id);
	for(var i=0;i < choices.length; i++){
        var li = document.createElement('li');
        li.appendChild(document.createTextNode(choices[i][0]));
		list.appendChild(li);
	}
} 
 
function OpenPopup(id,w,h){
	content = document.getElementById('content_'+id).childNodes[0].nodeValue;
	popupWin = window.open("", "",",scrollbars,height="+h+",width="+w+",top="+((screen.height-h)/2)+",left="+((screen.width-w)/2));
	var p = popupWin.document.createElement("p");
	p.align="center";
	var text = popupWin.document.createTextNode(content);
	p.appendChild(text);
	popupWin.document.body.appendChild(p);
	popupWin.focus();
}

// displaying annotation comment              
function msoCommentShow(anchor_id, com_id){
    c = document.getElementById(com_id);
    a = document.getElementById(anchor_id);
    if (null != c && null == c.length && null != a && null == a.length)
    {
    c.style.display = "block";
    var cw = c.offsetWidth;
    var ch = c.offsetHeight;
    var aw = a.offsetWidth;
    var ah = a.offsetHeight;
    var x  = a.offsetLeft;
    var y  = a.offsetTop;
  /*  var el = a;
    while (el.tagName != "BODY") 
    {
    el = el.offsetParent;
    x = x + el.offsetLeft;
    y = y + el.offsetTop;
    }
    var bw = document.body.clientWidth;
    var bh = document.body.clientHeight;
    var bsl = document.body.scrollLeft;
    var bst = document.body.scrollTop;*/
    
    el = document.getElementById('container-main-in');
    var bw = el.clientWidth;
    var bh = el.clientHeight;
    var bsl = el.scrollLeft;
    var bst = el.scrollTop;

    if (x + cw + ah / 2 > bw + bsl && x + aw - ah / 2 - cw >= bsl ) 
    { c.style.left = x + aw - ah / 2 - cw+'px'; }
    else 
    { c.style.left = x + ah / 2+'px'; }
    if (y + ch + ah / 2 > bh + bst && y + ah / 2 - ch >= bst ) 
    { c.style.top = y + ah / 2 - ch+'px'; }
    else 
    { c.style.top = y + ah / 2+'px'; }
   // c.style.display = "block";
    } 
}
function msoCommentHide(com_id){
    c = document.getElementById(com_id);
    if (null != c && null == c.length)
    {
    c.style.display = "none";
    c.style.left = '-1000px';
    c.style.top = '-1000px';
    } 
}      

// highlight search words
function checkHighlight(){
	//check menu selection(for hyperlinks)
	if (this.parent._wf_tree != undefined){
		doc = parent._wf_tree.document;
		posb = location.href.lastIndexOf("page");
		pose = location.href.lastIndexOf(".html");
		id = parseInt(location.href.substring(posb + 4, pose));
		var objCont = doc.getElementById('webfx-tree-object-' + id + '-cont');
		if (objCont != null) {
		    parentDiv = objCont.parentNode;
		    while (parentDiv != doc.getElementById('tree')) {
		        if (parentDiv.style.display != 'block') {
		            pos = parentDiv.id.indexOf('-cont');
		            i = parentDiv.id.substring(18, pos);
		            parentDiv.style.display = 'block';
		            doc.getElementById('webfx-tree-object-' + i + '-minus').style.display = 'inline';
		            doc.getElementById('webfx-tree-object-' + i + '-plus').style.display = 'none';
		        }
		        parentDiv = parentDiv.parentNode;
		    }
		}
	parent._wf_tree.select(id);
	}
	
	//check Highlight
	var remNode = false;
	var index = 0;
	var n = 0;
	var docWordVal = "";
	if (this.parent._wf_tree != undefined){
		if (this.parent._wf_tree.searchText != '') highlightText(this.parent._wf_tree.searchText.toLowerCase());
	}
	
	function highlightText(searchText)
	{
		while (searchText.indexOf("  ")>0){
			searchText = searchText.replace("  "," ");
		}
		var words = searchText.split(" ");
		for(i=0; i< words.length; i++){
			highlightWord(document.body,words[i]);
		}
	}
	
	
	function highlightWord(node,word) 
{
	// Iterate into this nodes childNodes
    if (node.nodeType == 3) 
    { // text node
	    var tempNodeVal = node.nodeValue.toLowerCase();
        for (var i = 0;i<node.nodeValue.length;i++)
		    if (node.nodeValue.charAt(i).toLowerCase()==word.charAt(index))
		    {
		        docWordVal = docWordVal+node.nodeValue.charAt(i);
    		    switch (index)
				{
	    		    case word.length-1:
			   	        finishNode = node;
		    	        finishIndex = i;
		    	        n++
		    	        if (startNode == finishNode)
		    	        {
	                        var pn = startNode.parentNode;
		                    if (pn.className != "searchword") 
		                    {
			                    // word has not already been highlighted!
			                    var nv = startNode.nodeValue;
			                    // Create a load of replacement nodes
			                    var before = document.createTextNode(nv.substr(0,startIndex));
			                    var after = document.createTextNode(nv.substr(finishIndex+1));
                    			var hiwordtext = document.createTextNode(docWordVal);
			                    var hiword = document.createElement("span");
			                    hiword.className = "searchword";
			                    hiword.appendChild(hiwordtext);
			                    pn.insertBefore(before,startNode);
			                    pn.insertBefore(hiword,startNode);
			                    pn.insertBefore(after,startNode);
			                    pn.removeChild(startNode);
			                    node = hiwordtext;
                            }
                            	index=0;
			    	            docWordVal = "";
			    	    }
			    	    else
			    	    {
		                    removeWord(document.body);
                        	var pn = startNode.parentNode;
		                    var hiword = document.createElement("span");
		                    var hiwordtext = document.createTextNode(docWordVal);
		                    hiword.className = "searchword";
		                    hiword.appendChild(hiwordtext);
		                    //это потому что нет insertAfter()
		                    temp = startNode.cloneNode(true);
		                    pn.insertBefore(temp,startNode);
		                    pn.replaceChild(hiword,startNode);
		                    index=0;
		                    i=-1;
			    	        docWordVal = "";
			    	    }
				        break;
				    case 0:
			            startNode = node;
			            startIndex = i;
			            index++;
				        break;
			        default:
			            index++;
			            break;
			    }
			}
			else
			{
			    if (index!=0)
			        i--;
		        index = 0;
		        docWordVal = "";
		    }
	}

	// And do this node itself
	for (var hi_cn = 0;hi_cn<node.childNodes.length;hi_cn++) 
	    highlightWord(node.childNodes[hi_cn],word);
}

function removeWord(node)
{
    if (node.nodeType == 3) 
    {
        switch (node)
        {
            case startNode:
                remNode = true;
                startNode.nodeValue=startNode.nodeValue.substr(0,startIndex);
                break;
            case finishNode:
                finishNode.nodeValue=finishNode.nodeValue.substr(finishIndex+1);
                remNode = false;
                break;
            default:
                if (remNode)
                    node.nodeValue = "";
                break;
        }
    }
	for (var hi_cn = 0;hi_cn<node.childNodes.length;hi_cn++) 
	    removeWord(node.childNodes[hi_cn]);
}
}       

        